/* CS6 - Channel Services src/chan_node_tools.c
 * CS5.0, CS5.1 and CS6.0 Copyright  1998-1999 Chris Birch(IRCore)
 */

#include<bot.h>

int delete_bnode(char *chan, char *ban)
{
   struct regsinfo *regs;
   struct baninfo *current, *previous, *tmp;

   strip_newline(ban);
   regs = regshead;
   while(regs != NULL)
   {
      if(!strcasecmp(chan, regs->channel))
      {
	 current = regs->banhead;
	 while(current != NULL)
	 {
	    if(!strcasecmp(ban, current->ban)) break;
	    else
	    {
	       previous = current;
	       current = current->next;
	    }
	 }
	 if(current == NULL) return 0;
	 else
	 {
	    if(current == regs->banhead) regs->banhead = regs->banhead->next;
	    else previous->next = current->next;
	    free(current);
	    return 1;
	 }
      }
      regs = regs->next;
   }
   return 0;
}

   void delete_cnode(char *chan, char *who)
   {  
      struct nickinfo *nick;
      struct chaninfo *current, *previous, *tmp;

      nick = nickhead;
      while(nick != NULL)
      {  
	 if(!strcasecmp(who, nick->nick))
	 {  
	    current = nick->chanhead;
	    while(current != NULL)
	    {
	       if(!strcasecmp(chan, current->channel)) break;
	       else
	       {
		  previous = current;
		  current = current->next;
	       }
	    }
	    if(current == NULL) return;
	    else
	    {
	       if(current == nick->chanhead) nick->chanhead = nick->chanhead->next;
	       else previous->next = current->next;
               tmp = current->next;
	       free(current);
               current = tmp;
	    }
	 }
	 nick = nick->next;
      }
   }

   void replace_mnode(char *chan, char *modes)
   {
      struct regsinfo *current;

      if(regshead == NULL) return;
      if(!ison(chan)) return;
      current = regshead;
      while(current != NULL)
      {
	 if(!strcasecmp(chan, current->channel))
	 {
	    strcpy(current->pmodes, current->modes);
	    strcpy(current->modes, modes);
	 }
	 current = current->next;
      }
   }

void delete_channel_node(char *chan)
{
   struct regsinfo *current, *previous, *tmp;
   struct baninfo *ban, *previous2, *tmp2;
   struct userinfo *user, *previous1, *tmp1;
   struct adderinfo *addr, *previous3, *tmp3;
   struct numinfo *num, *previous4, *tmp4;

   current = regshead;
   while(current != NULL)
   {
      if(!strcasecmp(chan, current->channel)) break;
      else
      {
	 previous = current;
	 current = current->next;
      }
   }
   if(current == NULL) return;
   else
   {
      user = current->userhead;
      while(user != NULL)
      {
	 addr = user->adderhead;
	 while(addr != NULL)
	 {
	    if(addr == user->adderhead) user->adderhead = user->adderhead->next;
	    else previous3->next = addr->next;
	    tmp3 = addr->next;
	    free(addr);
	    addr = tmp3;
	 }
	 num = user->numhead;
	 while(num != NULL)
	 {
	    if(num == user->numhead) user->numhead = user->numhead->next;
	    else previous4->next = num->next;
	    tmp4 = num->next;
	    free(num);
	    num = tmp4;
	 }
	 if(user == current->userhead) current->userhead = current->userhead->next;
	 else previous1->next = user->next;
	 tmp1 = user->next;
	 free(user);
	 user=tmp1;
      }
      ban = current->banhead;
      while(ban != NULL)
      {
	 if(ban == current->banhead) current->banhead = current->banhead->next;
	 else previous2->next = ban->next;
	 tmp2 = ban->next;
	 free(ban);
	 ban=tmp2;
      }
      if(current == regshead) regshead = regshead->next;
      else previous->next = current->next;
      tmp=current->next;
      free(current);
      current = tmp;
   }
}

   void delete_mail(char *uhost)
   {
      struct mailinfo *current, *previous, *tmp;
      struct suppinfo *supp, *tmp1;

      current = mailhead;
      while(current != NULL)
      {
	 if(!strcasecmp(uhost, current->ownermask))
	 {
	    if(current == NULL) return;
	    else
	    {
	       supp = current->supphead;
	       while(supp != NULL)
	       {
		  tmp1 = supp->next;
		  free(supp);
		  supp=tmp1;
	       }
	       if(current == mailhead) mailhead = mailhead->next;
	       else previous->next = current->next;
	       tmp=current->next;
	       free(current);
	       current = tmp;
	    }
	 }
	 else
	 {
	    previous = current;
	    current = current->next;
	 }
      }
   }

void delete_snode(char *server)
{
   struct nickinfo *current, *tmp;
   char tmpchar[1000];
   int gotit = 0;

   tmpchar[0] = '\0';
   current = nickhead;
   while(current != NULL)
   {
      tmp = current->next;
      if(!strcasecmp(server, current->server))
      {
	 delete_node(current->numeric);
      }
      current = tmp;
   }
}
