/* CS6 - Channel Services src/csdeauth.c
 * CS5.0, CS5.1 and CS6.0 Copyright  1998-1999 Chris Birch(IRCore)
 */

#include <bot.h>

void csdeauth(char *who, char *rest)
{
   struct regsinfo *regs;
   struct userinfo *user;
   struct numinfo *num;
   char *nwho = NULL, *nick = NULL;

   nwho = nick2num(who);
   nick = strtok(rest, " ");
   regs = regshead;
   while(regs != NULL)
   {
      if(!strcasecmp(csadminchan, regs->channel))
      {
	 user = regs->userhead;
	 while(user != NULL)
	 {
	    if(!strcasecmp(nick, user->nick))
	    {
	       num = user->numhead;
	       while(num != NULL)
	       {
		  if(!strcmp(nwho, num->numeric))
		  {
		     delete_auth(csadminchan, who);
		     delete_numnode(csadminchan, nick, nwho);
		     send_to_server(":%s NOTICE %s :Authorization Has Been Removed\n", botnick, nwho);
		     return; 
		  }
		  num = num->next;
	       }
	    }
	    user = user->next;
	 }
      }
      regs = regs->next;
   }
}
