/* CS6 - Channel Services src/dauthorize.c
 * CS5.0, CS5.1 and CS6.0 Copyright  1998-1999 Chris Birch(IRCore)
 */

#include <bot.h>

void dauthorize(char *who, char *rest)
{
   struct regsinfo *regs;
   struct userinfo *user;
   struct numinfo *num;
   char *nwho = NULL, *nick = NULL, *chan = NULL, *helpname = NULL;

   nwho = nick2num(who);
   chan = strtok(rest, " ");
   if(chan_check(chan, who) == -1) return;
   if(check(chan, who) == -1) return;
   nick = strtok(NULL, " ");
   helpname = get_command_name("deauth");
   if(nick == NULL)
   {
      do_help(who, helpname);
      return;
   }
   regs = regshead;
   while(regs != NULL)
   {
      if(!strcasecmp(chan, regs->channel))
      {
	 user = regs->userhead;
	 while(user != NULL)
	 {
	    if(!strcasecmp(nick, user->nick))
	    {
	       num = user->numhead;
	       while(num != NULL)
	       {
		  if(!strcmp(nwho, num->numeric))
		  {
		     delete_auth(chan, who);
		     delete_numnode(chan, nick, nwho);
		     send_to_server(":%s NOTICE %s :Authorization Has Been Removed\n", botnick, nwho);
		     return;
		  }
		  num = num->next;
	       }
	    }
	    user = user->next;
	 }
      }
      regs = regs->next;
   }
}
