/* CS6 - Channel Services src/add_admin.c
 * CS5.0, CS5.1 and CS6.0 Copyright  1998-1999 Chris Birch(IRCore)
 */
void credits(char *, char *);
void copyright(char *, char *);
void country(char *, char *);
void admin_csdauth(char *, char *);
void admin_dauth(char *, char *);
void devoice(char *, char *);
void givevoice(char *, char *);
void list_cuss(char *, char *);
void add_cuss(char *, char *);
void del_cuss(char *, char *);
int is_cuss(char *, char *);
char *collapse(char *);
char strlwr(char *);
char *strupr(char *);
char *conv_char(char *);
char *conv_oct(char *);
char translate_esc(char *, char *);
char *getuserhost(char *);
char *getnickuserhost(char *);
char *convert_addr(char *address);
char *get_ban_mask(char *);
char *get_mask(char *);
char *list_modes(char *);
char *date();
char *bottime();
char *get_command_name(char *);
char *get_command_rname(char *);
char *get_time(long);
char *mkpass(char *, char *);
char *num2serv(char);
char *nick2num(char *);
char *num2nick(char *);
char get_free_servnum(char *, char);
char *get_free_usernum(char *);
char *get_usernum(char *);
char *swap_host(char *);
int max_level(char *, char *, int);
int add_baninfo(char *, char *, long, int, long, char *, char *, int);
int add_user_addrinfo(char *, char *, char *);
int bancmp(const char *, const char *);
int chan_check(char *, char *);
int check(char *, char *);
int check_chan(char *);
int delete_bnode(char *, char *);
int ison(char *);
int check_purge_flag(char *);
int check_level(char *, char *);
int check_level_help(char *, char *, char *);
int is_char(char *num);
int check_access(char *, char *, int, char *);
int check_flood(char *);
int find_flood(char *);
int countdots(char *);
int is_num(char *);
int is_ip(char *);
int is_serv(char *);
int suppcount(char *);
int send_to_server(char *, ...);
int get_command_level(char *);
int ban_ccount(char *);
int ban_icount(char *);
int user_count(char *);
int get_connection(char *, int);
int readln();
int read_from_socket(int, char *);
int writeln(char *);
int writeln2(int, char *);
int send_to_socket(int, char *, ...);
int reconnect();
int set_chaninfo(char *, char *, int);
int compare (const void *, const void *);                                                
int do_sort(int cnt, char *cmds[ ]);
int delete_addrnode(char *, char *, char *);
int delete_numnode(char *, char *, char *);
int wcmp(char *, char *);
long max_duration(char *, char *, long);
long convert_duration(char *, long);
struct regsinfo *is_registered(char *);
struct baninfo *return_baninfo(char *, char *);
struct regsinfo *return_regsinfo(char *);
struct mailinfo *return_mailinfo(char *);
struct userinfo *return_maskinfo(char *, char *);
struct userinfo *return_userinfo(char *, char *);
struct userinfo *ret_user_access(char *, char *);
struct adderinfo *ret_user_addrinfo(char *, char *);
struct userinfo *ret_user_nickinfo(char *, char *);
struct userinfo *ret_user_level(char *, char *);
struct authinfo *return_authinfo(char *, char *);
struct nickinfo *return_chaninfo(char *, char *);
struct nickinfo *return_nickinfo(char *);
void add_admin(char *, char *);
void add_mapinfo(char *);
void add_burst(char *, char *, long);
void add_suppinfo(char *, int);
void add_mailinfo(char *, char *, char *, char *, char *, long);
void add_templist(char *, char *);
void add_modeinfo(char *, char *, char *);
void add_mode(char *, char *);
void add_topic(char *, char *);
void add_regsinfo(char *, long, char *, char *, char *, char *, char *, char *, char *, char *, long, char *, char *, char *, char *, char *, int, int, int, int, int, int, int, int, int, int, int, int, long, int, int, int, int, int, int, int);
void add_user(char *, char *);
void add_userinfo(char *, char *, int, int, int, int, int, char *, long);
void add_user_numinfo(char *, char *, char *);
void add_nickinfo(char *, char *, char *, char *, char *, char *);
void add_authinfo(char *, char *);
void add_joininfo(char *, char *, int, long);
void add_infoinfo(char *, char *, char *);
void addthishost(char *, char *);
void alist(char *, char *);
void authorize(char *, char *);
void authop(char *, char *);
void ban(char *, char *);
void show_bans(char *, char *);
void sig_alrm();
void sig_kill();
void sig_term();
void sig_hup();
void sig_segv();
void sig_pipe();
void sig_bus();
void change_comm_level(char *, char *);
void change_comm_name(char *, char *);
void disablecomm(char *, char *);
void enablecomm(char *, char *);
void showdisabled(char *, char *);
void chan_list(char *, char *);
void delete_cnode(char *, char *);
void replace_mnode(char *, char *);
void delete_channel_node(char *);
void delete_mail(char *);
void delete_snode(char *);
void check_channel_purge_time();
void purge_channel(char *);
void admin_purge_channel(char *, char *);
void show_chaninfo(char *, char *);
void channel_options(char *, char *);
void strip_chars(char *);
void log(char *, char *, ...);
void strip_newline(char *);
void del_wild(char *);
void strip_period(char *);
void strip_slash(char *);
void strip_bslash(char *);
void trailing_blanks(char *);
void enforce_ban(char *, char *);
void check_single_ban_time(char *);
void check_ban_times();
void clearban(char *, char *);
void csauth(char *, char *);
void csdeauth(char *, char *);
void ctcp_ping(char *, char *);
void ctcp_gender(char *, char *);
void ctcp_version(char *, char *);
void dauthorize(char *, char *);
void delete_admin(char *, char *);
void delete_user(char *, char *);
void add_to_flood_list(char *);
void reset_flood();
void set_flood_rate(char *, char *);
void flood_user(char *, char *);
void parse_admin(char *, char *);
void parse_stats(char *, char *);
void parse_version(char *, char *);
void delete_all_mail();
void free_maplist();
void free_burst();
void free_hublist();
void free_templist();
void free_banlist(char *);
void free_regslist();
void free_nicklist();
void get_ip(char *, char *);
void get_dns(char *, char *);
void do_help(char *, char *);
void help(char *, char *);
void info(char *, char *);
void suspend(char *, char *);
void add_servinfo(char *, char *);
void isauthed(char *, char *);
void isregistered(char *, char *);
void show_map(char *, char *);
void join_channels();
void join_msgchan();
void join(char *, char *);
void part(char *, char *);
void kick_ban(char *, char *);
void load_cfg();
void load_channels();
void load_banfiles(char *);
void load_infolines(char *);
void load_commands();
void load_nums();
void mailreg(char *, char *);
void update_mailinfo(char *, char *, char *, char *, char *, long );
void purpose(char *, char *);
void supporter(char *, char *);
void mail_it(char *, char *);
void kick_ban_all(char *, char *);
void kick_all(char *, char *);
void kick_user(char *, char *);
void clearmode(char *, char *);
void show_uptime(char *, char *);
void moderate(char *, char *);
void deopall(char *, char *);
void opall(char *, char *);
void opers_invite(char *, char *);
void invite(char *, char *);
void inviteme(char *, char *);
void say_text(char *, char *);
void do_action(char *, char *);
void default_modes(char *);
void re_op_x();
void lastseen(char *, char *);
void admin(char *, char *);
void generic(char *, char *);
void mode(char *, char *);
void cswall(char *, char *);
void list_suspendchan(char *, char *);
void show_chan_num(char *, char *);
void verify_pass(char *, char *);
void change_owner(char *, char *);
void debug(char *, ...);
void command_log(char *, char *, char *);
void send_denied_msg(char *);
void file_error(char *);
void mod_admin(char *, char *);
void mod_user(char *, char *);
void show_welcome(char *, char *);
void do_voice(char *, char *);
void show_motd(char *, char *);
void nickban(char *, char *);
void serv_unused(char *);
void serv_used(char, char *);
void delete_usernum(char *);
void deop(char *, char *);
void giveop(char *, char *);
void operlist(char *, char *);
void opregister_channel(char *, char *);
void parse(char *);
void parse_burst(char *, char *);
void parse_create(char *, char *);
void parse_eoburst();
void parse_eob_ack();
void parse_join(char *, char *);
void parse_kick(char *, char *);
void parse_kill(char *, char *);
void parse_mode(char *, char *);
void parse_nick(char *, char *);
void parse_part(char *, char *);
void parse_privmsg(char *, char *);
void parse_quit(char *, char *);
void parse_action(char *, char *);
void parse_away(char *, char *);
void parse_367(char *, char *);
void parse_353(char *, char *);
void parse_007(char *, char *);
void parse_005(char *, char *);
void parse_332(char *, char *);
void parse_324(char *, char *);
void parse_server(char *, char *);
void parse_server_msg(fd_set *read_fds);
void parse_ping(char *, char *);
void parse_connect(char *, char *);
void parse_pong(char *, char *);
void parse_squit(char *, char *);
void parse_pass(char *, char *);
void refresh_registered(char *, char *);
void register_channel(char *, char *);
void rehash();
void renchan(char *, char *);
void sendping();
void init_bot();
void reinit();
void die(char *, char *);
void set_welcome(char *, char *);
void set_ownername(char *, char *);
void set_url(char *, char *);
void set_default_modes(char *, char *);
void set_voice(char *, char *);
void suspend_channel(char *, char *);
void set_tlock(char *, char *);
void set_default_topic(char *, char *);
void make_motd(char *, char *);
void make_welcome(char *, char *);
void purge_flag(char *, char *);
void set_strictop(char *, char *);
void set_noban(char *, char *);
void set_stay(char *, char *);
void set_noops(char *, char *);
void set_autoops(char *, char *);
void set_operop(char *, char *);
void set_desc(char *, char *);
void set_ownernick(char *, char *);
void set_owneremail(char *, char *);
void set_chmodelvl(char *, char *);
void set_bantimeout(char *, char *);
void set_banremove(char *, char *);
void set_banmove(char *, char *);
void set_banlevel(char *, char *);
void new_password(char *, char *);
void new_apassword(char *, char *);
void show_access(char *, char *);
void showcommands(char *, char *);
void topic(char *, char *);
void set_topicnumber();
void default_topic(char *chan);
void reset_all_defs(char *, char *);
void reset_defmodes(char *, char *);
void reset_deftopic(char *, char *);
void reset_all_deftopics();
void reset_all_current_topics();
void parse_topic(char *, char *);
void unban(char *, char *);
void unregister_channel(char *, char *);
void delete_unode(char *, char *);
void delete_auth(char *, char *);
void purge_auth(char *);
void replace_onode(char *, char *, int);
void replace_node(char *, char *);
void delete_node(char *);
void delete_auth_chan(char *, char *);
void verify(char *, char *);
void whois(char *, char *);
void write_single_channel(char *);
void write_all_banfile();
void write_single_banfile(char *);
void write_single_infolines(char *);
void write_all_infolines();
void write_channel_list();
void write_comm_list();
void write_regs_list();
void write_all_files();
