/* CS6 - Channel Services src/parse.c
 * CS5.0, CS5.1 and CS6.0 Copyright  1998-1999 Chris Birch(IRCore)
 */

#include <bot.h>

void parse(char *line)
{
   struct regsinfo *regs, *regs1;
   int i = 0;
   char *sample = NULL, *nline = NULL, *cmd = NULL, *rest = NULL, *who = NULL, test[1000], *server = NULL, *botnum = NULL;
   char *samp1 = NULL, *samp2 = NULL, *samp3 = NULL, *samp4 = NULL, *samp5 = NULL, *samp6 = NULL, *ptr = NULL, *ptr1 = NULL, nrest[10000], logit[10000];
   char *usernum = NULL, *nwho = NULL, chantest[10000], rrest[10000], *chan, kban[10000];
   int nick_server = 0;

   test[0] = '\0';
   nrest[0] = '\0'; 
   logit[0] = '\0';
   usernum=get_usernum(bot.nick);
   trailing_blanks(line);
   if(strlen(line) > 524)
   {
      return;
   }
   strcpy(test, line);
   if(is_serv(test) || *line == ':')
   {
      if (!strncmp(line,":SERVER",7))
	 nick_server = 1;
      line++;
      if(cmd = strchr(line, ' ')) *cmd++ = '\0';
      who = line;
      if(rest = strchr(cmd, ' ')) *rest++ = '\0';
      else
      {
	 if(strcmp(cmd, "EOB_ACK") && strcmp(cmd, "END_OF_BURST") && strcmp(cmd, "AWAY"))
	 {
	    if(who = strchr(line, ' ')) *who++ = '\0';
	    cmd = line;
	 }
      }
      if(!strcmp(cmd, "PRIVMSG") && *rest == '#')
      {
	 strcpy(rrest, rest);
	 strlwr(rrest);
	 strcpy(chantest, rest);
	 chan = strtok(chantest, " ");
	 regs = return_regsinfo(chan);
	 if(regs != NULL && regs->sban)
	 {
	    if(is_cuss(chan, rrest))
	    {
	       sprintf(kban, "%s %s %s No Swearing - Banned for %s", chan, who, regs->sweartime, regs->sweartime);
	       kick_ban(botnick, kban);
	    }
	 }
	 if(regs != NULL && regs->aban && strstr(rest, "ACTION") && strstr(rrest, "away"))
	 {
	    sprintf(kban, "%s %s %s No Away Messages - Banned for %s", chan, who, regs->awaytime, regs->awaytime);
	    kick_ban(botnick, kban);
	 }
	 if(strcmp(cmd, "ACTION") && strcmp(cmd, "AWAY") && who[0] != '\0')
	 {
	    if(ptr = strchr(rest, ' ')) *ptr++ = '\0';
	    *ptr++;
	    if(*ptr == comchar)
	    {
	       *ptr++;
	       if(ptr1 = strchr(ptr, ' ')) *ptr1++ = '\0';
	       for(i = 0; *commands[i].name; i++) 
	       {
		  if(!strcasecmp(ptr, commands[i].name) && commands[i].secure && ptr1 == NULL) 
		  {
		     strlwr(ptr);
		     do_help(who, ptr);
		     return;
		  }
		  if(!strcasecmp(ptr, commands[i].name) && commands[i].secure && ptr1 != NULL) 
		  {
		     nwho = nick2num(who);
		     send_to_server(":%s NOTICE %s : Security Violation - Possible open display of password\n", bot.nick, nwho);
		     send_to_server(":%s NOTICE %s : Please use private message to %s when using passwords\n", bot.nick, nwho, bot.nick);
		     return;
		  }
		  if(!strcasecmp(ptr, commands[i].name) && commands[i].nochan) 
		  {
		     if(ptr1 != NULL)
			sprintf(nrest, "%s :%s %s", usernum, ptr, ptr1);
		     else
			sprintf(nrest, "%s :%s", usernum, ptr);
		     rest = nrest;
		  }
		  else if(!strcasecmp(ptr, commands[i].name) && !commands[i].nochan) 
		  {
		     if(ptr1 != NULL)
		     {
			if(ptr1[0] == '#')
			   sprintf(nrest, "%s :%s %s", usernum, ptr, ptr1);
			else
			   sprintf(nrest, "%s :%s %s %s", usernum, ptr, rest, ptr1);
		     }
		     else
			sprintf(nrest, "%s :%s %s", usernum, ptr, rest);
		     rest = nrest;
		  }
	       }
	       botnum=get_usernum(bot.nick);
	       if(!strcmp(cmd, "PRIVMSG") && strstr(rest, botnum) && logging)
	       {
		  sprintf(logit, ":%s %s %s\n", who, cmd, rest);
		  log(BOT_LOG, "R [%s] %s",date(), logit);
	       }
	    }
	    else return;
	 }
      }
   }
   else
   {
      strcpy(test, line);
      who=strtok(test, " ");
      if(strcasecmp(who, "PASS"))
      {
	 if(cmd = strchr(line, ' ')) *cmd++ = '\0';
	 if(rest = strchr(cmd, ' ')) *rest++ = '\0';
      }
      else
      {
	 if(who = strchr(line, ' ')) *who++ = '\0';
	 cmd = line;
	 rest = NULL;
      }
   }
   if(rest != NULL)
      if(rest[0] == '#' && !strcmp(cmd, "PRIVMSG")) return;

#ifdef DEBUG
   printf("Parse - Command: [%s] Who: [%s] Rest: [%s]\n", cmd, who, rest);  
#endif
   if(who != NULL)
   {
      if(!strcmp(who, "SERVER") && !nick_server)
      {
	 samp1=strtok(rest, " ");
	 samp2=strtok(NULL, " ");
	 samp3=strtok(NULL, " ");
	 samp4=strtok(NULL, " ");
	 samp5=strtok(NULL, " ");
	 serv_used(*samp5, cmd);
      }
      if(!strcmp(cmd, "SERVER"))
      {
	 who = test;
      }
   }
#ifdef DEBUG
   if(msglog)
   {
      if(strcmp(cmd,"PONG") && strcmp(cmd, "PRIVMSG") && strcmp(cmd, "BURST"))
      {
	 command_log(who, cmd, rest);
      }
   }
#endif

   for(i = 0;*parse_command[i].name; i++) 
   {
      if(!strcmp(cmd, parse_command[i].name)) 
      {
	 parse_command[i].function(who, rest);
	 return;
      }
   }
}
