/* CS6 - Channel Services src/parse_kick.c
 * CS5.0, CS5.1 and CS6.0 Copyright  1998-1999 Chris Birch(IRCore)
 */

#include <bot.h>

void parse_kick(char *who, char *rest)
{
   char *chan = NULL, *nick = NULL, *reason = NULL, *nnick = NULL, *nwho = NULL, *ban_per = NULL, *uhost = NULL;
   struct userinfo *tmp, *tmp1, *tmp3;
   struct regsinfo *tmp2;
   struct authinfo *admnauth, *userauth;

   chan = strtok(rest, " ");
   nick = strtok(NULL, " ");
   reason = strtok(NULL, " ");
   nnick=num2nick(nick);
   nwho=nick2num(who);
   delete_cnode(chan, nnick);
   if(nwho == NULL) return;
   tmp2 = return_regsinfo(chan);
   if(tmp2 == NULL) return;
   if(tmp2->suspend) return;
   tmp3 = return_userinfo(who, chan);
   tmp1 = return_userinfo(nnick, csadminchan);
   admnauth = return_authinfo(csadminchan, nnick);
   if(tmp1 != NULL &&  admnauth != NULL)
   {
      if(tmp1->protect)
      {
	 if(tmp3 != NULL && tmp3->level == maxuserlevel) return;
	 uhost = getuserhost(who);
	 ban_per = get_ban_mask(uhost);
	 send_to_server(":%s MODE %s -o+b %s %s\n", bot.nick, chan, nwho, ban_per);
	 send_to_server(":%s KICK %s %s :%s is protected!\n", bot.nick, chan, nwho, nnick);
	 add_baninfo(chan, ban_per, time(NULL), tmp2->banlvl, tmp2->bantimeout, "Kicked a Protected user", nnick, 1);
      }
   }
   else 
   {
      tmp = return_userinfo(nnick, chan); 
      userauth = return_authinfo(chan, nnick);
      if(tmp != NULL &&  userauth != NULL)
      {
	 if(tmp->protect)
	 {
	    if(tmp3 != NULL && tmp3->level == maxuserlevel) return;
	    uhost = getuserhost(who);
	    ban_per = get_ban_mask(uhost);
	    send_to_server(":%s MODE %s -o+b %s %s\n", bot.nick, chan, nwho, ban_per);
	    send_to_server(":%s KICK %s %s :%s is protected!\n", bot.nick, chan, nwho, nnick);
	    add_baninfo(chan, ban_per, time(NULL), tmp2->banlvl, tmp2->bantimeout, "Kicked a Protected user", nnick, 1);
	 }
      }
   }
}
