/* CS6 - Channel Services src/rehash.c
 * CS5.0, CS5.1 and CS6.0 Copyright  1998-1999 Chris Birch(IRCore)
 */

#include<bot.h>

void rehash()
{
   int i;
   char *botnum = NULL;

   botnum=get_usernum(bot.nick);
   write_all_files();
   delete_usernum(botnum);
   free_hublist();
   free_nicklist();
   send_to_server(":%s WALLOPS :Re-initializing Channel Services\n", myserver);
   if(ymsgchan)
      send_to_server(":%s PRIVMSG %s :Re-initializing Channel Services.\n", bot.nick, msg_chan);
   send_to_server(":%s QUIT :%s\n", bot.nick, quit_msg);
   send_to_server(":%s SQUIT %s :Just keeps getting better and better !\n", myserver, myserver);
   close(socketfd);
   load_cfg();
   if((i = get_connection(bot.server, bot.port)) != -1)
   {
      log(LOG_FILE, "[%s] Rehashing %s\n", date(), bot.nick);
      socketfd = i;
      init_bot();
   }
}
