/* CS6 - Channel Services src/ret_regsinfo.c
 * CS5.0, CS5.1 and CS6.0 Copyright  1998-1999 Chris Birch(IRCore)
 */

#include<bot.h>

int ban_ccount(char *channel)
{
   struct regsinfo *regs;
   struct baninfo *ban;
   int i = 0;

   regs = regshead;
   while(regs != NULL)
   { 
      ban = regs->banhead;
      while(ban != NULL)
      {
	 if(!ban->botban)
	    i++;
	 ban = ban->next;
      }
      regs = regs->next;
   }
   bccount = i;
   return(bccount);
}

int ban_icount(char *channel)
{
   struct regsinfo *regs;
   struct baninfo *ban;
   int i = 0;

   regs = regshead;
   while(regs != NULL)
   { 
      ban = regs->banhead;
      while(ban != NULL)
      {
	 if(ban->botban)
	    i++;
	 ban = ban->next;
      }
      regs = regs->next;
   }
   bicount = i;
   return(bicount);
}

int user_count(char *channel)
{
   struct nickinfo *nick;
   struct chaninfo *chan;
   int i = 0;

   nick = nickhead;
   while(nick != NULL)
   { 
      chan = nick->chanhead;
      while(chan != NULL)
      {
	 if(!strcasecmp(channel, chan->channel))
	 {
	    i++;
	 }
	 chan = chan->next;
      }
      nick = nick->next;
   }
   ucount = i;
   return(ucount);
}

struct baninfo *return_baninfo(char *chan, char *banmask)
{
   struct regsinfo *current;
   struct baninfo *ban;

   current = regshead;
   while(current != NULL) 
   {
      if(!strcasecmp(chan, current->channel)) 
      {
	 ban = current->banhead;
	 while(ban != NULL)
	 {
	    if(!strcasecmp(banmask, ban->ban))
	    {
	       if(ban->botban)
		  return ban;
	       else 
		  return NULL;
	    }
	    ban = ban->next;
	 }
      }
      current = current->next;
   }
   return NULL;
}

struct regsinfo *return_regsinfo(char *chan)
{
   struct regsinfo *current;

   current = regshead;
   while(current != NULL) 
   {
      if(!strcasecmp(chan, current->channel)) 
      {
	 return current;
      }
      current = current->next;
   }
   return NULL;
}

struct mailinfo *return_mailinfo(char *uhost)
{
   struct mailinfo *mail;

   mail = mailhead;
   while(mail != NULL)
   {
      if(!strcasecmp(uhost, mail->ownermask))
      {
	 return mail;
      }
      mail = mail->next;
   }
   return NULL;
}

int is_cuss(char *chan, char *rest)
{
   struct regsinfo *regs;
   struct cussinfo *cuss;

   regs = regshead;
   while(regs != NULL)
   {
      if(!strcasecmp(regs->channel, chan))
      {
	 cuss = regs->cusshead;
	 while(cuss != NULL)
	 {
	    if(strstr(rest, cuss->word))
	    {
	       return 1;
	    }
	    cuss = cuss->next;
	 }
	 return 0;
      }
      regs = regs->next;
   }
}  
