/* CS6 - Channel Services src/join_chan.c
 * CS5.0, CS5.1 and CS6.0 Copyright  1998-1999 Chris Birch(IRCore)
 */

#include<bot.h>

void join_channels()
{
   struct modeinfo *mode;
   struct regsinfo *current;
   struct nickinfo *nicktmp;
   struct chaninfo *chantmp;
   char *usernum = NULL;
   int first_time = 0;
   long stamp = 0;

   joined = FALSE;
   usernum=get_usernum(bot.nick);
   current = regshead;
   while(current != NULL) 
   {
      if(!current->suspend && strcasecmp(current->channel, msg_chan))
      {
	 if(current->chanstamp != NULL && current->chanstamp[0] != '\0')
	 {
	    stamp = atol(current->chanstamp);
	    send_to_server("%c BURST %s %ld %s:o\n", convert2y[server_num], current->channel, stamp, usernum);
	    add_joininfo(current->channel, usernum, TRUE, time(NULL));
	 }
	 else if(current->stay)
	 {
	    send_to_server("%c BURST %s %ld %s:o\n", convert2y[server_num], current->channel, time(NULL), usernum);
	    add_joininfo(current->channel, usernum, TRUE, time(NULL));
	 }
      }
      current = current->next;
   }
   send_to_server("%c END_OF_BURST\n", convert2y[server_num]);
   current = regshead;
   while(current != NULL) 
   {
      default_modes(current->channel);
      default_topic(current->channel);
      send_to_server(":%s MODE %s\n", bot.nick, current->channel);
      if(deopchan)
	 deopall(bot.nick, current->channel);
      load_infolines(current->channel);
      load_banfiles(current->channel);
      load_cuss_words(current->channel);
      enforce_chan_bans(current->channel);
      current = current->next;
   }
   joined = TRUE;
   free_maplist();
   end_map = 0;
   send_to_server(":%s MAP\n", bot.nick);
   load_commands();
   free_burst();
}
